#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivitySailingaSignRepeatedlyCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivitySailingaSignRepeatedlyCFG> M_ActivitySailingaSignRepeatedlyCFG::msSingleton(nullptr);

int M_ActivitySailingaSignRepeatedlyCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingaSignRepeatedlyCFGData* M_ActivitySailingaSignRepeatedlyCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivitySailingaSignRepeatedlyCFGData>& M_ActivitySailingaSignRepeatedlyCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingaSignRepeatedlyCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivitySailingaSignRepeatedlyCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingaSignRepeatedlyCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mDay = element->Attribute("Day");
		data.mAwardItemID = element->IntAttribute("AwardItemID");
		data.mAwardItemCounts = element->IntAttribute("AwardItemCounts");
		data.mAllDay = element->IntAttribute("AllDay");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		assert(mMapData.find(data.mId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivitySailingaSignRepeatedlyCFG::Load()
{
	Load("../Config/M_ActivitySailingaSignRepeatedlyCFG.xml");
}

M_ActivitySailingaSignRepeatedlyCFG* M_ActivitySailingaSignRepeatedlyCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingaSignRepeatedlyCFG());
	}
	return msSingleton.get();
}
